if not confexists("RPM::GPG-Check") or confget("RPM::GPG-Check/b") == "false" then
	return
end

print("Checking GPG signatures...")
good = 1
unknown = 0
illegal = 0
unsigned = 0

for i, file in ipairs(files_install) do
    inp = io.popen("LANG=C /bin/rpm --checksig  "..file.." 2>&1")
    for line in inp.lines(inp) do
        if string.find(line, "gpg") then
            break
        elseif string.find(line, "GPG") then
            print("Unknown signature "..line)
			unknown = unknown + 1
            good = nil
        elseif string.find(line, "rpmReadSignature") then
            print("Illegal signature "..line)
			illegal = illegal + 1
            good = nil
        else
            print("Unsigned "..line)
			unsigned = unsigned + 1
			good = nil
        end
    end
end

if not good then
	apterror("Error: "..unsigned.." unsigned packages\n"..unknown.." unknown signatures\n"..illegal.." illegal/corrupted signatures")
end
